// Test cases for format #4:
//  xxx operator=(xxx C &p) { (&p != this) [{]...[}] [return;] }

// Okay.
class Okay4A {
public:
  int a;
  void operator=(Okay4A &rhs)
  {
    if (&rhs != this) {
      a = rhs.a;
    }
  }
};


// Okay.
class Okay4B {
public:
  int a;
  Okay4B &operator=(Okay4B &rhs)
  {
    if (&rhs != this) {
      a = rhs.a;
    }
    return *this;
  }
};


// VIOLATION: code before test
class Violation4A {
public:
  int a;
  void operator=(Violation4A &rhs)
  {
    a; // does nothing, but is a violation
    if (&rhs != this)
      a = rhs.a;
  }
};


// VIOLATION: code after test
class Violation4B {
public:
  int a;
  void operator=(Violation4B &rhs)
  {
    if (&rhs != this)
      a = rhs.a;
    a; // does nothing, but is a violation
  }
};


// VIOLATION: test is wrong
class Violation4C {
public:
  int a;
  void operator=(Violation4C &rhs)
  {
    if (&rhs != &rhs)
      a = rhs.a;
  }
};


// VIOLATION: test is wrong
class Violation4D {
public:
  int a;
  void operator=(Violation4D &rhs)
  {
    if (&rhs < this)
      a = rhs.a;
  }
};
