typedef float broken1;
void func() {
  const broken1 & broken1;
  float obj2;
  broken1==obj2;
}


// Test: floating-point value equality comparison

void okay1() {
  int a,b;
  float c;
  a==b;
  a==1;
  1==a;
  a==0xe0; // okay, not floating
  a==(int)c;
  (int)c==a;
}


void violation1() {
  int a;
  float b;
  double c;
  a==b;   // violation
  a==c;   // violation
  b==c;   // violation
  a==1.0; // violation
  1.0==a; // violation
  a==1.;  // violation
  a==1e1; // violation
}


struct struct1 {
  float b;
};

void limitation1() {
  int a;
  float b;
  struct1 c;
  a==1+b;       // should be violation
  a==c.b;       // should be violation
  (int) c.b==0; // should not be violation
}


