void notRecursive_a() {
	notRecursive_b();
}

void notRecursive_b() {
	/* even though it calls some other recursive function here, neither of these
	 * two are considered "unsafe" -- the function below is the one that's a
	 * violation */
	directRecursion();
}

void directRecursion() {
	directRecursion(); /* obviously "unsafe" */
}

void indirectRecursion1_a() {
	indirectRecursion1_b();
}

void indirectRecursion1_b() {
	indirectRecursion1_a();
}

void indirectRecursion2_a() {
	indirectRecursion2_b();
}

void indirectRecursion2_b() {
	indirectRecursion2_c();
}

void indirectRecursion2_c() {
	if (0) {
		/* even if it's potentially unreachable, recursion is considered
		 * "unsafe" */
		indirectRecursion2_a();
	}
}
