typedef short int ( * CallbackFn )( short int a, short int b );
short int Callback_1 ( short int a, short int b ) // Compliant
{
  return a + b;
}
short int Callback_2 ( short int a, short int b ) // Non-compliant
{
  return a;
}
short int Callback_3 ( short int, short int b ) // Compliant by exception
{
  return b;
}
void Dispatch ( short int n,
				short int a,
				short int b,
				short int c, // Non-compliant
				short int ) // Non-compliant if Dispatch not a callback.
{
	CallbackFn pFn;
	switch ( n )
	{
		case 0: pFn = &Callback_1; break;
		case 1: pFn = &Callback_2; break;
		default: pFn = &Callback_3; break;
	}
	( *pFn )( a, b );
}

class Functor {
public:
	void operator()() {}
};

template <typename Predicate>
void foo(Predicate predicate)
{
	predicate(); // Compliant
}

int main()
{
	Functor f;
	foo(f);
}
