#include "posix_typedefs.h"

typedef bool boolean;
typedef boolean boolean_indirect;

typedef uint32_t uint32_indirect;

struct SomeStruct {
	int invalidField : 4;
	signed int validSigned : 2;
	unsigned int validUnsigned: 1;
	char invalidChar : 2;
	unsigned char invalidUnsignedChar : 2;
	signed char invalidSignedChar : 2;
	bool validBool : 1;
	boolean validBoolean : 1;
	boolean_indirect validIndirectBoolean : 1;
	uint32_t validUint32 : 8;
	char_t invalidChar : 3;
	uint32_indirect validIndirectUint32 : 7;
};

struct S
{
     signed int    a : 2; // Compliant
   unsigned int    b : 2; // Compliant
             char  c : 2; // Non-compliant
     signed char   d : 2; // Compliant
   unsigned char   e : 2; // Compliant
             short f : 2; // Non-compliant
     signed short  g : 2; // Compliant
   unsigned short  h : 2; // Compliant
             int   i : 2; // Non-compliant
             bool  j : 2; // Compliant
          wchar_t  k : 2; // Non-compliant
         uint32_t  l : 2; // Compliant
           int8_t  m : 2; // Compliant
};
