#include "8.4copatibleDeclarationVisibleWhenExternalLinkageIsDefined.h"

extern short count;
short count = 0; 							/* Compliant 															*/

// Strict already checks for this
//extern unsigned short speed = 6000u; 		/* Non-compliant - no declaration
//											 * prior to this definition 											*/

unsigned short pressure = 101u; 			/* Non-compliant - no declaration
											 * prior to this definition 											*/

unsigned short pressure2 = 102u;			/* Compliant - Declared in header file									*/

extern void func1 ( void );
extern void func2 ( short x, short y );
extern void func3 ( short x, short y );

void func1 ( void )
{
											/* Compliant 															*/
}

void func2 ( short x, short y )
{
											/* Compliant 															*/
}

// Strict already checks for this
//void func3 ( short x, unsigned short y )
//{
											/* Non-compliant - parameter types different 							*/
//}
void func4 ( void )
{
											/* Non-compliant - no declaration of func4 before this definition 		*/
}
static void func5 ( void )
{
											/* Compliant - rule does not apply to objects/functions with internal
											 * linkage 																*/
}

void func6 ( void )
{
											/* Compliant -  Declaration in header file 								*/
}

// Strict already checks for this
//int func7 ( void )
//{
											/* Non-compliant - Incompatible declaration in header file 				*/
//}
