// Test that function parameters take objects by value.

typedef int *Type1;
typedef char *Type2;
typedef char Type3;
typedef Type3 Type4,*Type5;


void Okay2(     // Some built-in types are okay.
  char *p1)
{
  *p1;
}

void Okay3(     // Not a ptr type.
  int p)
{
  p;
}

void Okay4(     // Never dereferenced.
  int *p1,
  Type1 p2)
{
  p1;
  p2;
}

void func1(int *);
void Okay5(     // Passed to function without deref.
  int *p)
{
  *p;
  func1(p);
}

void Okay6(	// Dereference function pointer is okay.
  void (*p6)())
{
  (*p6)();
  p6();
}

void Okay7(     // Some built-in types are okay.
  Type2 p1,
  Type4 *p2,
  Type5 p3)
{
  *p1;
  *p2;
  *p3;
}

void Violation1(
  int *p)
{
  *p;
}

void func2(int);
void Violation2(
  int *p)
{
  p;
  func2(*p);
}

void Violation3(
  int *p)
{
  p[0];
}

void Violation4(
  int *p)
{
  p[1] = 0;
}

int Violation5(
  int *p)
{
  return *p;
}

void Violation6(     // User-defined type is not special
  Type1 p)
{
  *p;
}

void Violation7(
  struct Struct1 *p)
{
  *p;
}
