typedef int int16_t;

void foo() {
	
	
	int16_t x;
	
	switch ( x )
	{
	case 0:
		++x;
		break;
	case 1:
	case 2:
		break;
		/* Non-compliant - default label is required */
	}

	
	int16_t y;
	int16_t errorflag;

	switch ( y )
	{
	case 0:
		++y;
		break;
	case 1:
	case 2:
		break;
	default: /* Compliant - default label is present */
		errorflag = 1; /* should be non-empty if possible */
		break;
	}

	
	int16_t next;
	enum Colours
	{ 
		RED, 
		GREEN, 
		BLUE 
	} colour;

	switch ( colour )
	{
	case RED:
		next = GREEN;
		break;
	case GREEN:
		next = BLUE;
		break;
	case BLUE:
		next = RED;
		break;
		/* Non-compliant - no default label.
		* Even though all values of the enumeration are
		* handled there is no guarantee that colour takes
		* one of those values */
	}
	
	
}
