class Base
{
public:
  virtual void g1_831 ( int a = 0 );
  virtual void g2_831 ( int a = 0 );
  virtual void b1_831 ( int a = 0 );
};

class Derived : public Base
{
public:
  virtual void g1_831 ( int a = 0 );     // Compliant - same default used
  virtual void g2_831 ( int a );         // Compliant -
                                         // no default specified
  virtual void b1_831 ( int a = 10 );    // Non-compliant - different value
};

void f( Derived& d )
{
  Base& b = d;
  b.g1_831 ( );   // Will use default of 0
  d.g1_831 ( );   // Will use default of 0
  b.g2_831 ( );   // Will use default of 0
  d.g2_831 ( 0 ); // No default value available to use
  b.b1_831 ( );   // Will use default of 0
  d.b1_831 ( );   // Will use default of 10
}
